<copyright> tomgnome gnomehello-2-i18n example.
    A rewrite in TOM of the original gnome-hello-0-basic.c example,
    as it appears in the gnome-libs distribution.
    By <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: GnomeHello2I18n.t,v 1.3 1999/02/17 23:25:33 tiggr Exp $</id>
    </copyright>

<doc> As GnomeHello is about a GnomeApp, I choose to use the
      Gnome way of generating Menus instead of the Gtk way used
      in the c language demo.
</doc>

implementation class
GnomeHello: gtomk.Constants
{
  GnomeApp app;
}

int
  main MutableArray args
{
  [Gnome init "tom-gnome-hello-2-i18n" args args];

  [self prepare_app];

  /* This method does not return.  */
  [gtomk main];
}

void
  prepare_app
{
  /* Makes the main window and binds the delete event so you can close
     the program from your WM */
  
  app = [GnomeApp new ("hello", ["Hello World Gnomified (TomGnome)" i18n: "wintitle"])];
  [app realize];
  [app connect "delete_event" 
       to self using selector(void quit) 
       overrideArguments: NO];

  /* setup the Menu structure. The used objects are:
     GnomeUIArray: Is an array of GnomeUIInfo elements. Usually used with the
                   factory message "with ()"
     elements:
     GnomeUIInfoItem: Menuitem with optional XPM (xpm:) and stock graphics (stock:)
     GnomeUIInfoSubtree: Subtree that contains another GnomeUIArray.
  */
  GnomeUIArray filemenu = [GnomeUIArray with ([GnomeUIInfoItem new ["Exit" i18n: "Menu"]
							       to [Invocation 
								    for selector (void quit)
								    to: self]
							       tip: ["Click here to quit."
								      i18n: "hint"]
							       stock: "Menu_Quit"])];
  GnomeUIArray aboutmenu = [GnomeUIArray with ([GnomeUIInfoItem new ["About" i18n: "Menu"]
								to [Invocation
								     for selector (void about)
								     to: self]
								tip: ["Click here for info."
								       i18n: "hint"]
								stock: "Menu_About"])];
  GnomeUIArray menu = [GnomeUIArray with ([GnomeUIInfoSubtree new ["File" i18n: "Menu"] 
							      subtree filemenu],
					  [GnomeUIInfoSubtree new ["Help" i18n: "Menu"]
							      subtree aboutmenu])];
  /* Let GnomeApp create the menu and handle it ;) */

  [app create_menus menu];

  /* Notice, that in TOM variable declaration don't have to be at beginning
     of the scope. */
  GtkWidget button;
  /* We make a button, bind the 'clicked' signal to hello and setting it
     to be the content of the main window */
  button = [GtkButton new_with_label "Hello GNOME"];
  [button connect "clicked"
	  to self using selector(void hello)];
  [app set_contents button];
  
  /* We now show the widgets, the order doesn't matter, but i suggests 
     showing the main window last so the whole window will popup at
     once rather than seeing the window pop up, and then the button form
     inside of it. Although with such simple example, you'd never notice. */
  [button show];
  [app show];
}

void
  hello
{
  /* notice, that nl prints \n AND flushes the stream. */
  [[[stdio out] print "Hello GNOME"] nl];
  [gtomk main_quit];
}

void
  quit
{
  [gtomk main_quit];
}

void
  about
{
  GnomeAbout ga = [GnomeAbout new ["The Hello World Gnomified (TomGnome)" i18n: "abouttitle"]
			      version "0.0"
			      copyright "(c) 1998 Andreas Kostyrka"
			      authors [ObjectArray with ("Andreas Kostyrka")]
			      comments ["This is a TOM version of the GnomeHello demo."
					 i18n: "aboutcomment"]
			      logo nil];
  [ga show];
}

end;

implementation instance
GnomeHello

end;
