<copyright> gdomk Bitmap class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Bitmap.t,v 1.3 1998/04/09 09:42:00 tiggr Exp $</id>
    </copyright>

<c>
#include "glue.h"
</c>

implementation class
GdkBitmap: GdkWrapper

instance (id)
  create_from_data (GdkWindow, pointer, int, int)
		   (window, data, width, height)
{
  pointer p, wobj = [window gdkWindow];
<c>
  p = gdk_bitmap_create_from_data (wobj, data, width, height);
</c>
  = [[self alloc] init p];
<c>
  gdk_bitmap_unref (p);
</c>
}

end;

implementation instance
GdkBitmap

<doc> Return the {GdkBitmap} for which this object stands.  </doc>
pointer
  gdkBitmap
{
  = object;
}

<doc> Designated initializer.  Reference the bitmap.  </doc>
id
  init pointer p
{
  = [super init p];
<c>
  gdk_bitmap_ref (p);
</c>
}

<doc> Release the bitmap {object} if not done yet.  </doc>
void
  dealloc
{
  if (!!object)
    {
      pointer obj = object;
<c>
      gdk_bitmap_unref (obj);
</c>
      [super dealloc];
    }
}

id
  ref
{
  pointer obj = object;
<c>
  gdk_bitmap_ref (obj);
</c>
  = self;
}

void
  unref
{
  pointer obj = object;
<c>
  gdk_bitmap_unref (obj);
</c>
}

end;
