<copyright> gdomk Rectangle class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Rectangle.t,v 1.2 1998/04/29 18:53:15 yacc Exp $</id>
    </copyright>

<c>
#include <stdlib.h>
#include "glue.h"
</c>

implementation class
GdkRectangle : State

/* methods: */

end;

implementation instance
GdkRectangle
{
  pointer object;
}

<doc> Return the {GdkRectangle} for which this object stands.  </doc>
pointer
  gdkRectangle
{
  = object;
}

/* methods: */

id
  initFromPtr pointer otherRectangle
{
  = self;

  pointer x = object;
  <c> {
    GdkRectangle *xr = x, *or = otherRectangle;
    if (!x) 
      xr = x = malloc(sizeof(GdkRectangle));
    *xr=*or;
  } </c>
  object = x;
}

id
  init 
{
  = self;

  pointer x = object;
  <c> {
    GdkRectangle *xr = x;
    static GdkRectangle zeroRect; /* last time I've checked, ANSI C makes
                                   * this zero inited :)
                                   * Andreas Kostyrka <yacc@gerbil.org>
                                   * Wed Apr 29 12:55:37 CEST 1998
				   */

    if (!x) 
      xr = x = malloc(sizeof(GdkRectangle));
    *xr = zeroRect;
  } </c>
  object = x;
}

void dealloc {
  pointer x = object;
  <c> free(x); </c>
}

void
  set_x char xv
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    xr->x = xv;
  } </c>
}

void
  set_y char yv
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    xr->y = yv;
  } </c>
}

void
  set_width char wv
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    xr->width = wv;
  } </c>
}

void
  set_height char hv
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    xr->height = hv;
  } </c>
}

char (x)
  x
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    x = xr->x;
  } </c>
}

char (y)
  y
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    y = xr->y;
  } </c>
}

char (wv)
  width
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    wv = xr->width;
  } </c>
}

char (hv)
  height
{
  pointer po = object;
  <c> {
    GdkRectangle *xr = po;
    hv = xr->height;
  } </c>
}

(GdkRectangle, boolean) (rect, res)
  intersect GdkRectangle otherrect
{
  pointer po = object;
  pointer por = [otherrect gdkRectangle];
  pointer pd;
  
  <c> {
    GdkRectangle *or = po, *orr = por;
    GdkRectangle *dr = alloca (sizeof(GdkRectangle));
    pd = dr;
    
    res = gdk_rectangle_intersect (or, orr, dr);
  } </c>
  
  rect = [[GdkRectangle alloc] initFromPtr pd];
}

end;
