<copyright> gdomk Region class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Region.t,v 1.2 1998/04/30 16:09:50 yacc Exp $</id>
    </copyright>

<c>
#include <stdlib.h>
#include "glue.h"
</c>

implementation class
GdkRegion : State

/* methods: */

end;

implementation instance
GdkRegion
{
  <doc> points to the gdk GdkRegion object. </doc>
  pointer object;
  <doc> if set, we will destroy it in dealloc. </doc>
  public mutable boolean owner;
}

<doc> Return the {GdkRegion} for which this object stands.  </doc>
pointer
  gdkRegion
{
  = object;
}

/* methods: */

id
  init
{
  owner = YES;

  pointer obj;
  <c> obj = gdk_region_new (); </c>
  object = obj;

  = self;
}

id
  initFromPtr pointer reg
{
  owner = NO;
  object = reg;
  = self;
}

void
  dealloc
{
  if (owner) 
    {
      pointer obj = object;
      <c> gdk_region_destroy ((GdkRegion *) obj); </c>
    }
}

boolean (res)
  empty
{
  pointer preg = object;
  <c> res = gdk_region_empty ((GdkRegion *) preg); </c>
}

boolean (res)
  equal GdkRegion or
{
  pointer preg = object;
  pointer por = [or gdkRegion];

  <c> res = gdk_region_equal ((GdkRegion *) preg, (GdkRegion *) por); </c>
}

boolean (res)
  point_in (int, int) (x, y)
{
  pointer preg = object;

  <c> res = gdk_region_point_in ((GdkRegion *) preg, x, y); </c>
}

int (GdkOverlapType_VALUE)
  rect_in GdkRectangle rect
{
  pointer preg = object;
  pointer prect = [rect gdkRectangle];
  <c> GdkOverlapType_VALUE = gdk_region_rect_in ((GdkRegion *) preg,
						 (GdkRectangle *) prect); </c>
}

void
  offset (int, int) (dx, dy)
{
  pointer preg = object;

  <c> gdk_region_offset ((GdkRegion *) preg, dx, dy); </c>

}

void
  shrink (int, int) (dx, dy)
{
  pointer preg = object;

  <c> gdk_region_shrink ((GdkRegion *) preg, dx, dy); </c>

}

id (res)
  union_with_rect GdkRectangle rect
{
  pointer preg = object;
  pointer prect = [rect gdkRectangle];
  pointer pdest;
  <c> pdest = gdk_region_union_with_rect ((GdkRegion *) preg,
					  (GdkRectangle *) prect); </c>
  res = [[GdkRegion alloc] initFromPtr pdest];
  [res set_owner YES];
}

id (res)
  intersect GdkRegion oreg
{
  pointer preg = object;
  pointer poreg = [oreg gdkRegion];
  pointer pdest;
  <c> pdest = gdk_regions_intersect ((GdkRegion *) preg,
				    (GdkRegion *) poreg); </c>
  res = [[GdkRegion alloc] initFromPtr pdest];
  [res set_owner YES];
}

id (res)
  union GdkRegion oreg
{
  pointer preg = object;
  pointer poreg = [oreg gdkRegion];
  pointer pdest;
  <c> pdest = gdk_regions_union ((GdkRegion *) preg,
				    (GdkRegion *) poreg); </c>
  res = [[GdkRegion alloc] initFromPtr pdest];
  [res set_owner YES];
}

id (res)
  subtract GdkRegion oreg
{
  pointer preg = object;
  pointer poreg = [oreg gdkRegion];
  pointer pdest;
  <c> pdest = gdk_regions_subtract ((GdkRegion *) preg,
				    (GdkRegion *) poreg); </c>
  res = [[GdkRegion alloc] initFromPtr pdest];
  [res set_owner YES];
}

id (res)
  xor GdkRegion oreg
{
  pointer preg = object;
  pointer poreg = [oreg gdkRegion];
  pointer pdest;
  <c> pdest = gdk_regions_xor ((GdkRegion *) preg,
				    (GdkRegion *) poreg); </c>
  res = [[GdkRegion alloc] initFromPtr pdest];
  [res set_owner YES];
}

/*
GdkRegion*     gdk_region_polygon   (GdkPoint      *points,
				     gint           npoints,
				     GdkFillRule    fill_rule);
*/

end;


