<copyright> gdomk Window class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Window.t,v 1.4 1998/07/29 22:05:38 yacc Exp $</id>
    </copyright>

<c>
#include "glue.h"
</c>

implementation class
GdkWindow: GdkDrawable

//GdkWindow*    gdk_window_new	     (GdkWindow	    *parent,
//				      GdkWindowAttr *attributes,
//				      gint	     attributes_mask);
//
//GdkWindow *   gdk_window_foreign_new (guint32	     anid);

end;

implementation instance
GdkWindow

<doc> Return the {GdkWindow} for which this object stands.  </doc>
pointer
  gdkWindow
{
  = object;
}

<doc> Designated initializer.  Reference the Window.  </doc>
id
  init pointer p
{
  = [super init p];
<c>
  gdk_window_ref (p);
</c>
}

<doc> Release the Window {object} if not done yet.  </doc>
void
  dealloc
{
  if (!!object)
    {
      pointer obj = object;
<c>
      gdk_window_unref (obj);
</c>
      [super dealloc];
    }
}

void
  set_cursor GdkCursor cursor
{
  pointer obj = object;
  pointer ccursor = [cursor gdkCursor];
  <c> gdk_window_set_cursor ((GdkWindow *)obj, (GdkCursor *)ccursor); </c>
}

//void	      gdk_window_destroy     (GdkWindow	    *window);
//GdkWindow*    gdk_window_ref	     (GdkWindow	    *window);
//void	      gdk_window_unref	     (GdkWindow	    *window);
//
//void	      gdk_window_show	     (GdkWindow	   *window);
//void	      gdk_window_hide	     (GdkWindow	   *window);
//void	      gdk_window_withdraw    (GdkWindow	   *window);
//void	      gdk_window_move	     (GdkWindow	   *window,
//				      gint	    x,
//				      gint	    y);
//void	      gdk_window_resize	     (GdkWindow	   *window,
//				      gint	    width,
//				      gint	    height);
//void	      gdk_window_move_resize (GdkWindow	   *window,
//				      gint	    x,
//				      gint	    y,
//				      gint	    width,
//				      gint	    height);
//void	      gdk_window_reparent    (GdkWindow	   *window,
//				      GdkWindow	   *new_parent,
//				      gint	    x,
//				      gint	    y);
//void	      gdk_window_clear	     (GdkWindow	   *window);
//void	      gdk_window_clear_area  (GdkWindow	   *window,
//				      gint	    x,
//				      gint	    y,
//				      gint	    width,
//				      gint	    height);
//void	      gdk_window_clear_area_e(GdkWindow	   *window,
//				      gint	    x,
//				      gint	    y,
//				      gint	    width,
//				      gint	    height);
//void	      gdk_window_copy_area   (GdkWindow	   *window,
//				      GdkGC	   *gc,
//				      gint	    x,
//				      gint	    y,
//				      GdkWindow	   *source_window,
//				      gint	    source_x,
//				      gint	    source_y,
//				      gint	    width,
//				      gint	    height);
//void	      gdk_window_raise	     (GdkWindow	   *window);
//void	      gdk_window_lower	     (GdkWindow	   *window);
//
//void	      gdk_window_set_user_data	 (GdkWindow	  *window,
//					  gpointer	   user_data);
//void	      gdk_window_set_override_redirect(GdkWindow  *window,
//					       gboolean override_redirect);
//
//void	      gdk_window_add_filter	(GdkWindow     *window,
//					 GdkFilterFunc	function,
//					 gpointer	data);
//void	      gdk_window_remove_filter	(GdkWindow     *window,
//					 GdkFilterFunc	function,
//					 gpointer	data);
//
///* 
// * This allows for making shaped (partially transparent) windows
// * - cool feature, needed for Drag and Drag for example.
// *  The shape_mask can be the mask
// *  from gdk_pixmap_create_from_xpm.   Stefan Wille
// */
//void gdk_window_shape_combine_mask (GdkWindow	    *window,
//				    GdkBitmap	    *shape_mask,
//				    gint	     offset_x,
//				    gint	     offset_y);
//
///* 
// * Drag & Drop
// * Algorithm (drop source):
// * A window being dragged will be sent a GDK_DRAG_BEGIN message.
// * It will then do gdk_dnd_drag_addwindow() for any other windows that are to be
// * dragged.
// * When we get a DROP_ENTER incoming, we send it on to the window in question.
// * That window needs to use gdk_dnd_drop_enter_reply() to indicate the state of
// * things (it must call that even if it's not going to accept the drop)
// *
// * These two turn on/off drag or drop, and if enabling it also
// * sets the list of types supported. The list of types passed in
// * should be in order of decreasing preference.
// */
//void gdk_window_dnd_drag_set (GdkWindow	 *window,
//			      guint8	  drag_enable,
//			      gchar	**typelist,
//			      guint	  numtypes);
//
///* 
// *XXX todo: add a GDK_DROP_ENTER which can look at actual data
// */
//void gdk_window_dnd_drop_set (GdkWindow	 *window,
//			      guint8	  drop_enable,
//			      gchar	**typelist,
//			      guint	  numtypes,
//			      guint8	  destructive_op);
//
///* 
// * This is used by the GDK_DRAG_BEGIN handler. An example of usage would be a
// * file manager where multiple icons were selected and the drag began.
// * The icon that the drag actually began on would gdk_dnd_drag_addwindow
// * for all the other icons that were being dragged... 
// */
//void gdk_dnd_drag_addwindow  (GdkWindow	 *window);
//void gdk_window_dnd_data_set (GdkWindow	 *window,
//			      GdkEvent	 *event,
//			      gpointer	  data,
//			      gulong	  data_numbytes);
//void gdk_dnd_set_drag_cursors(GdkCursor *default_cursor,
//			      GdkCursor *goahead_cursor);
//void gdk_dnd_set_drag_shape(GdkWindow *default_pixmapwin,
//			    GdkPoint *default_hotspot,
//			    GdkWindow *goahead_pixmapwin,
//			    GdkPoint *goahead_hotspot);
//
//void	      gdk_window_set_hints	 (GdkWindow	  *window,
//					  gint		   x,
//					  gint		   y,
//					  gint		   min_width,
//					  gint		   min_height,
//					  gint		   max_width,
//					  gint		   max_height,
//					  gint		   flags);
//void	      gdk_window_set_title	 (GdkWindow	  *window,
//					  const gchar	  *title);
//void	      gdk_window_set_background	 (GdkWindow	  *window,
//					  GdkColor	  *color);
//void	      gdk_window_set_back_pixmap (GdkWindow	  *window,
//					  GdkPixmap	  *pixmap,
//					  gint		   parent_relative);
//void	      gdk_window_set_colormap	 (GdkWindow	  *window,
//					  GdkColormap	  *colormap);
//void	      gdk_window_get_user_data	 (GdkWindow	  *window,
//					  gpointer	  *data);
//void	      gdk_window_get_geometry	 (GdkWindow	  *window,
//					  gint		  *x,
//					  gint		  *y,
//					  gint		  *width,
//					  gint		  *height,
//					  gint		  *depth);
//void	      gdk_window_get_position	 (GdkWindow	  *window,
//					  gint		  *x,
//					  gint		  *y);
//void	      gdk_window_get_size	 (GdkWindow	  *window,
//					  gint		  *width,
//					  gint		  *height);
//GdkVisual*    gdk_window_get_visual	 (GdkWindow	  *window);
//GdkColormap*  gdk_window_get_colormap	 (GdkWindow	  *window);
//GdkWindowType gdk_window_get_type	 (GdkWindow	  *window);
//gint	      gdk_window_get_origin	 (GdkWindow	  *window,
//					  gint		  *x,
//					  gint		  *y);

(GdkWindow, int, int, int) (child, x, y, GDK_something_MASK)
  get_pointer
{
  pointer obj = object, child_obj;

<c>
  {
    gint gx, gy;
    GdkModifierType gmask;

    child_obj = gdk_window_get_pointer (obj, &gx, &gy, &gmask);
    GDK_something_MASK = gmask;
    y = gy;
    x = gx;
  }
</c>

  if (!!child_obj)
    child = [GdkWindow proxy child_obj create: YES];
}

//GdkWindow*    gdk_window_get_parent	 (GdkWindow	  *window);
//GdkWindow*    gdk_window_get_toplevel	 (GdkWindow	  *window);
//GList*	      gdk_window_get_children	 (GdkWindow	  *window);
//GdkEventMask  gdk_window_get_events	 (GdkWindow	  *window);
//void	      gdk_window_set_events	 (GdkWindow	  *window,
//					  GdkEventMask	   event_mask);
//
//void	      gdk_window_set_icon	 (GdkWindow	  *window, 
//					  GdkWindow	  *icon_window,
//					  GdkPixmap	  *pixmap,
//					  GdkBitmap	  *mask);
//void	      gdk_window_set_icon_name	 (GdkWindow	  *window, 
//					  gchar		  *name);
//void	      gdk_window_set_group	 (GdkWindow	  *window, 
//					  GdkWindow	  *leader);
//void	      gdk_window_set_decorations (GdkWindow	  *window,
//					  GdkWMDecoration  decorations);
//void	      gdk_window_set_functions	 (GdkWindow	  *window,
//					  GdkWMFunction	   functions);

end;
