/* Generate GDK constants for use in gdomk.
   Written by Pieter Schoenmakers <tiggr@gerbil.org>

   Copyright &copy; 1998, 1999 Pieter J. Schoenmakers.

   This file is part of GDOMK.  GDOMK is distributed under the terms of
   the GNU Library General Public License, a copy of which can be found
   in the GDOMK distribution; see the file COPYING.LIB.

   $Id: gen-con.c,v 1.5 1999/02/15 21:57:08 tiggr Exp $  */

#include <gdk/gdk.h>

#define DI(MACRO)  \
  printf ("  const " #MACRO " = %d;\n", MACRO)

int
main (int argc, char **argv)
{
  printf ("implementation class Constants\n{\n");

  /* These are all values from gdk+-0.99.9/gdk/{gdktypes,gdkcursors}.h.  */

  DI (GDK_WINDOW_ROOT);
  DI (GDK_WINDOW_TOPLEVEL);
  DI (GDK_WINDOW_CHILD);
  DI (GDK_WINDOW_DIALOG);
  DI (GDK_WINDOW_TEMP);
  DI (GDK_WINDOW_PIXMAP);
  DI (GDK_WINDOW_FOREIGN);

  DI (GDK_INPUT_OUTPUT);
  DI (GDK_INPUT_ONLY);

  DI (GDK_IMAGE_NORMAL);
  DI (GDK_IMAGE_SHARED);
  DI (GDK_IMAGE_FASTEST);

  DI (GDK_VISUAL_STATIC_GRAY);
  DI (GDK_VISUAL_GRAYSCALE);
  DI (GDK_VISUAL_STATIC_COLOR);
  DI (GDK_VISUAL_PSEUDO_COLOR);
  DI (GDK_VISUAL_TRUE_COLOR);
  DI (GDK_VISUAL_DIRECT_COLOR);

  DI (GDK_FONT_FONT);
  DI (GDK_FONT_FONTSET);

  DI (GDK_WA_TITLE);
  DI (GDK_WA_X);
  DI (GDK_WA_Y);
  DI (GDK_WA_CURSOR);
  DI (GDK_WA_COLORMAP);
  DI (GDK_WA_VISUAL);
  DI (GDK_WA_WMCLASS);
  DI (GDK_WA_NOREDIR);

  DI (GDK_HINT_POS);
  DI (GDK_HINT_MIN_SIZE);
  DI (GDK_HINT_MAX_SIZE);

  DI (GDK_COPY);
  DI (GDK_INVERT);
  DI (GDK_XOR);

  DI (GDK_SOLID);
  DI (GDK_TILED);
  DI (GDK_STIPPLED);
  DI (GDK_OPAQUE_STIPPLED);

  DI (GDK_LINE_SOLID);
  DI (GDK_LINE_ON_OFF_DASH);
  DI (GDK_LINE_DOUBLE_DASH);

  DI (GDK_CAP_NOT_LAST);
  DI (GDK_CAP_BUTT);
  DI (GDK_CAP_ROUND);
  DI (GDK_CAP_PROJECTING);

  DI (GDK_JOIN_MITER);
  DI (GDK_JOIN_ROUND);
  DI (GDK_JOIN_BEVEL);

  DI (GDK_NUM_GLYPHS);
  DI (GDK_X_CURSOR);
  DI (GDK_ARROW);
  DI (GDK_BASED_ARROW_DOWN);
  DI (GDK_BASED_ARROW_UP);
  DI (GDK_BOAT);
  DI (GDK_BOGOSITY);
  DI (GDK_BOTTOM_LEFT_CORNER);
  DI (GDK_BOTTOM_RIGHT_CORNER);
  DI (GDK_BOTTOM_SIDE);
  DI (GDK_BOTTOM_TEE);
  DI (GDK_BOX_SPIRAL);
  DI (GDK_CENTER_PTR);
  DI (GDK_CIRCLE);
  DI (GDK_CLOCK);
  DI (GDK_COFFEE_MUG);
  DI (GDK_CROSS);
  DI (GDK_CROSS_REVERSE);
  DI (GDK_CROSSHAIR);
  DI (GDK_DIAMOND_CROSS);
  DI (GDK_DOT);
  DI (GDK_DOTBOX);
  DI (GDK_DOUBLE_ARROW);
  DI (GDK_DRAFT_LARGE);
  DI (GDK_DRAFT_SMALL);
  DI (GDK_DRAPED_BOX);
  DI (GDK_EXCHANGE);
  DI (GDK_FLEUR);
  DI (GDK_GOBBLER);
  DI (GDK_GUMBY);
  DI (GDK_HAND1);
  DI (GDK_HAND2);
  DI (GDK_HEART);
  DI (GDK_ICON);
  DI (GDK_IRON_CROSS);
  DI (GDK_LEFT_PTR);
  DI (GDK_LEFT_SIDE);
  DI (GDK_LEFT_TEE);
  DI (GDK_LEFTBUTTON);
  DI (GDK_LL_ANGLE);
  DI (GDK_LR_ANGLE);
  DI (GDK_MAN);
  DI (GDK_MIDDLEBUTTON);
  DI (GDK_MOUSE);
  DI (GDK_PENCIL);
  DI (GDK_PIRATE);
  DI (GDK_PLUS);
  DI (GDK_QUESTION_ARROW);
  DI (GDK_RIGHT_PTR);
  DI (GDK_RIGHT_SIDE);
  DI (GDK_RIGHT_TEE);
  DI (GDK_RIGHTBUTTON);
  DI (GDK_RTL_LOGO);
  DI (GDK_SAILBOAT);
  DI (GDK_SB_DOWN_ARROW);
  DI (GDK_SB_H_DOUBLE_ARROW);
  DI (GDK_SB_LEFT_ARROW);
  DI (GDK_SB_RIGHT_ARROW);
  DI (GDK_SB_UP_ARROW);
  DI (GDK_SB_V_DOUBLE_ARROW);
  DI (GDK_SHUTTLE);
  DI (GDK_SIZING);
  DI (GDK_SPIDER);
  DI (GDK_SPRAYCAN);
  DI (GDK_STAR);
  DI (GDK_TARGET);
  DI (GDK_TCROSS);
  DI (GDK_TOP_LEFT_ARROW);
  DI (GDK_TOP_LEFT_CORNER);
  DI (GDK_TOP_RIGHT_CORNER);
  DI (GDK_TOP_SIDE);
  DI (GDK_TOP_TEE);
  DI (GDK_TREK);
  DI (GDK_UL_ANGLE);
  DI (GDK_UMBRELLA);
  DI (GDK_UR_ANGLE);
  DI (GDK_WATCH);
  DI (GDK_XTERM);
  DI (GDK_LAST_CURSOR);
  DI (GDK_CURSOR_IS_PIXMAP);

  DI (GDK_FILTER_CONTINUE);
  DI (GDK_FILTER_TRANSLATE);
  DI (GDK_FILTER_REMOVE);

  DI (GDK_VISIBILITY_UNOBSCURED);
  DI (GDK_VISIBILITY_PARTIAL);
  DI (GDK_VISIBILITY_FULLY_OBSCURED);

  DI (GDK_NOTHING);
  DI (GDK_DELETE);
  DI (GDK_DESTROY);
  DI (GDK_EXPOSE);
  DI (GDK_MOTION_NOTIFY);
  DI (GDK_BUTTON_PRESS);
  DI (GDK_2BUTTON_PRESS);
  DI (GDK_3BUTTON_PRESS);
  DI (GDK_BUTTON_RELEASE);
  DI (GDK_KEY_PRESS);
  DI (GDK_KEY_RELEASE);
  DI (GDK_ENTER_NOTIFY);
  DI (GDK_LEAVE_NOTIFY);
  DI (GDK_FOCUS_CHANGE);
  DI (GDK_CONFIGURE);
  DI (GDK_MAP);
  DI (GDK_UNMAP);
  DI (GDK_PROPERTY_NOTIFY);
  DI (GDK_SELECTION_CLEAR);
  DI (GDK_SELECTION_REQUEST);
  DI (GDK_SELECTION_NOTIFY);
  DI (GDK_PROXIMITY_IN);
  DI (GDK_PROXIMITY_OUT);
  DI (GDK_DRAG_ENTER);
  DI (GDK_DRAG_LEAVE);
  DI (GDK_DRAG_MOTION);
  DI (GDK_DRAG_STATUS);
  DI (GDK_CLIENT_EVENT);
  DI (GDK_VISIBILITY_NOTIFY);
  DI (GDK_NO_EXPOSE);

  DI (GDK_EXPOSURE_MASK);
  DI (GDK_POINTER_MOTION_MASK);
  DI (GDK_POINTER_MOTION_HINT_MASK);
  DI (GDK_BUTTON_MOTION_MASK);
  DI (GDK_BUTTON1_MOTION_MASK);
  DI (GDK_BUTTON2_MOTION_MASK);
  DI (GDK_BUTTON3_MOTION_MASK);
  DI (GDK_BUTTON_PRESS_MASK);
  DI (GDK_BUTTON_RELEASE_MASK);
  DI (GDK_KEY_PRESS_MASK);
  DI (GDK_KEY_RELEASE_MASK);
  DI (GDK_ENTER_NOTIFY_MASK);
  DI (GDK_LEAVE_NOTIFY_MASK);
  DI (GDK_FOCUS_CHANGE_MASK);
  DI (GDK_STRUCTURE_MASK);
  DI (GDK_PROPERTY_CHANGE_MASK);
  DI (GDK_VISIBILITY_NOTIFY_MASK);
  DI (GDK_PROXIMITY_IN_MASK);
  DI (GDK_PROXIMITY_OUT_MASK);
  DI (GDK_ALL_EVENTS_MASK);

  DI (GDK_NOTIFY_ANCESTOR);
  DI (GDK_NOTIFY_VIRTUAL);
  DI (GDK_NOTIFY_INFERIOR);
  DI (GDK_NOTIFY_NONLINEAR);
  DI (GDK_NOTIFY_NONLINEAR_VIRTUAL);
  DI (GDK_NOTIFY_UNKNOWN);

  DI (GDK_SHIFT_MASK);
  DI (GDK_LOCK_MASK);
  DI (GDK_CONTROL_MASK);
  DI (GDK_MOD1_MASK);
  DI (GDK_MOD2_MASK);
  DI (GDK_MOD3_MASK);
  DI (GDK_MOD4_MASK);
  DI (GDK_MOD5_MASK);
  DI (GDK_BUTTON1_MASK);
  DI (GDK_BUTTON2_MASK);
  DI (GDK_BUTTON3_MASK);
  DI (GDK_BUTTON4_MASK);
  DI (GDK_BUTTON5_MASK);

  DI (GDK_CLIP_BY_CHILDREN);
  DI (GDK_INCLUDE_INFERIORS);

  DI (GDK_INPUT_READ);
  DI (GDK_INPUT_WRITE);
  DI (GDK_INPUT_EXCEPTION);

  DI (GDK_OK);
  DI (GDK_ERROR);
  DI (GDK_ERROR_PARAM);
  DI (GDK_ERROR_FILE);
  DI (GDK_ERROR_MEM);

  DI (GDK_LSB_FIRST);
  DI (GDK_MSB_FIRST);

  DI (GDK_GC_FOREGROUND);
  DI (GDK_GC_BACKGROUND);
  DI (GDK_GC_FONT);
  DI (GDK_GC_FUNCTION);
  DI (GDK_GC_FILL);
  DI (GDK_GC_TILE);
  DI (GDK_GC_STIPPLE);
  DI (GDK_GC_CLIP_MASK);
  DI (GDK_GC_SUBWINDOW);
  DI (GDK_GC_TS_X_ORIGIN);
  DI (GDK_GC_TS_Y_ORIGIN);
  DI (GDK_GC_CLIP_X_ORIGIN);
  DI (GDK_GC_CLIP_Y_ORIGIN);
  DI (GDK_GC_EXPOSURES);
  DI (GDK_GC_LINE_WIDTH);
  DI (GDK_GC_LINE_STYLE);
  DI (GDK_GC_CAP_STYLE);
  DI (GDK_GC_JOIN_STYLE);

  DI (GDK_SELECTION_PRIMARY);
  DI (GDK_SELECTION_SECONDARY);

  DI (GDK_PROPERTY_NEW_VALUE);
  DI (GDK_PROPERTY_DELETE);

  DI (GDK_PROP_MODE_REPLACE);
  DI (GDK_PROP_MODE_PREPEND);
  DI (GDK_PROP_MODE_APPEND);

  DI (GDK_SOURCE_MOUSE);
  DI (GDK_SOURCE_PEN);
  DI (GDK_SOURCE_ERASER);
  DI (GDK_SOURCE_CURSOR);

  DI (GDK_MODE_DISABLED);
  DI (GDK_MODE_SCREEN);
  DI (GDK_MODE_WINDOW);

  DI (GDK_AXIS_IGNORE);
  DI (GDK_AXIS_X);
  DI (GDK_AXIS_Y);
  DI (GDK_AXIS_PRESSURE);
  DI (GDK_AXIS_XTILT);
  DI (GDK_AXIS_YTILT);
  DI (GDK_AXIS_LAST);

  DI (GDK_TARGET_BITMAP);
  DI (GDK_TARGET_COLORMAP);
  DI (GDK_TARGET_DRAWABLE);
  DI (GDK_TARGET_PIXMAP);
  DI (GDK_TARGET_STRING);

  DI (GDK_SELECTION_TYPE_ATOM);
  DI (GDK_SELECTION_TYPE_BITMAP);
  DI (GDK_SELECTION_TYPE_COLORMAP);
  DI (GDK_SELECTION_TYPE_DRAWABLE);
  DI (GDK_SELECTION_TYPE_INTEGER);
  DI (GDK_SELECTION_TYPE_PIXMAP);
  DI (GDK_SELECTION_TYPE_WINDOW);
  DI (GDK_SELECTION_TYPE_STRING);

  DI (GDK_EXTENSION_EVENTS_NONE);
  DI (GDK_EXTENSION_EVENTS_ALL);
  DI (GDK_EXTENSION_EVENTS_CURSOR);

  DI (GDK_DECOR_ALL);
  DI (GDK_DECOR_BORDER);
  DI (GDK_DECOR_RESIZEH);
  DI (GDK_DECOR_TITLE);
  DI (GDK_DECOR_MENU);
  DI (GDK_DECOR_MINIMIZE);
  DI (GDK_DECOR_MAXIMIZE);
			
  DI (GDK_FUNC_ALL);
  DI (GDK_FUNC_RESIZE);
  DI (GDK_FUNC_MOVE);
  DI (GDK_FUNC_MINIMIZE);
  DI (GDK_FUNC_MAXIMIZE);
  DI (GDK_FUNC_CLOSE);

  DI (GDK_CC_MODE_UNDEFINED);
  DI (GDK_CC_MODE_BW);
  DI (GDK_CC_MODE_STD_CMAP);
  DI (GDK_CC_MODE_TRUE);
  DI (GDK_CC_MODE_MY_GRAY);
  DI (GDK_CC_MODE_PALETTE);

  DI (GDK_OVERLAP_RECTANGLE_IN);
  DI (GDK_OVERLAP_RECTANGLE_OUT);
  DI (GDK_OVERLAP_RECTANGLE_PART);

  DI (GDK_CURRENT_TIME);
  DI (GDK_NONE);

  printf ("}\nend;\nimplementation instance Constants end;\n");

  return 0;
}
