<copyright> gtomk Object class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: glib.t,v 1.1 1998/04/22 09:11:33 yacc Exp $</id>
    </copyright>

<c>
#include <glib.h>
</c>

implementation class GenericWrapper : tom.All

<doc> give as a proxy object for a pointer. </doc>

deferred instance (id) (object)
     proxy pointer gtk_object
     create: boolean create_p = NO
post
object != nil;

<doc> give as the pointer of a given proxy object.
      This is at the moment not used,
      but would be needed for a full glib wrapping.
</doc>

deferred pointer 
  ptrvalue instance (id) object;
end;

implementation instance GenericWrapper
end;

<doc> GList isn't actually thought for public use. It's more of a helper
      class for accessor functions in Gtk/Gdk objects.
</doc>

implementation class GList : State
end;

implementation instance GList {
  pointer glist;
  class(GenericWrapper) wrapper;
}

pointer
  object
{
  = glist;
}

Any (res)
  data
{
  pointer p=[self data];
  = Any ([wrapper proxy p create: YES]);
}

boolean (res)
  valid
{
  if (!glist) return NO;

  pointer p=[self data];
  = !!p;
}

pointer (res)
  data
{
  pointer x=glist;

  <c> {
    GList *gl= (GList *) x;
    res=gl->data;
  } </c>

}

boolean (res)
  prev
{
  pointer x=glist;
  <c> {
    GList *gl= (GList *) x;
    if (gl->prev) {
      gl=gl->prev;
      x=gl;
      res=1;
    } else {
      res=0;
    }
  } </c>
  glist=x;
}

boolean (res)
  next 
{
  pointer x=glist;
  <c> {
    GList *gl= (GList *) x;
    if (gl->next) {
      gl=gl->next;
      x=gl;
      res=1;
    } else {
      res=0;
    }
  } </c>
  glist=x;
}

id 
         init pointer gl 
  withWrapper class(GenericWrapper) wr
{
  glist=gl;
  wrapper=wr;
  = self;
}

id 
  init class(GenericWrapper) wr
post 
  !!glist 
{
  = self;
  wrapper=wr;
  {
    pointer v;
    <c> v= (GList *) g_list_alloc (); </c>
    glist=v;
  }
}

void
  dealloc 
{
  pointer v=glist;
  <c> if (v) g_list_free (v); </c>
}

/* helper methods: */

<doc> returns the forward contents of the {GList} as an {ObjectArray}. </doc>

ObjectArray 
  asObjectArray
{
  MutableObjectArray result=[MutableObjectArray new];

  /* This is wrong in a multithreaded environment, but then GTK isn't
   * up to multithreaded yet for some time.
   * Wed Apr 22 10:28:20 CEST 1998 <yacc@gerbil.org>
   */
  pointer save=glist;

  boolean ende= ![self valid];
  while (!ende) {
    [result add Any ([self data])];
    ende=![self next];
  }

  [result freeze];		/* make sure nobody cheats. */
  glist=save;
  = result;
}


end;
