<copyright> gtomk CTree class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: CTree.t,v 1.1 1998/06/16 11:42:29 yacc Exp $</id>
    </copyright>

<gtk_version>1.1.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkCTree: GtkCList


instance (id)
  new (int, int) (columns, tree_column)
{
  pointer p;
<c>
  p = gtk_ctree_new (columns, tree_column);
</c>
  = [[self alloc] init p];
}

instance (id)
  new_with_titles (Array, int) (titles, tree_column)
{
  int i, len, columns = [titles length];
  String title;
  pointer p;

<c>
  {
    char *s, **c_titles = alloca (columns * sizeof (*c_titles));
</c>

    for (i = 0; i < columns; i++)
      {
	title = titles[i];
<c>
	C_STRING_WITH_TOM_STRING (s, len, title);
	c_titles[i] = s; 
</c>
      }

<c>
    p = gtk_ctree_new_with_titles (columns, tree_column, c_titles);
  }
</c>
  = [[self alloc] init p];
}


end;

implementation instance
GtkCTree

<doc> Return the {gtkCTree} for which this object stands.  </doc>
pointer
  gtkCTree
{
  = object;
}

end;

<comment>
GList *     gtk_ctree_insert                (GtkCTree     *ctree,
					     GList        *parent, 
					     GList        *sibling,
					     gchar        *text[],
					     guint8        spacing,
					     GdkPixmap    *pixmap_closed,
					     GdkBitmap    *mask_closed,
					     GdkPixmap    *pixmap_opened,
					     GdkBitmap    *mask_opened,
					     gboolean      is_leaf,
					     gboolean      expanded);
void       gtk_ctree_remove                 (GtkCTree     *ctree, 
					     GList        *node);
void       gtk_ctree_clear                  (GtkCTree     *ctree);

/***********************************************************
 *  Generic recursive functions, querying / finding tree   *
 *  information                                            *
 ***********************************************************/

void       gtk_ctree_post_recursive         (GtkCTree     *ctree, 
					     GList        *node,
					     GtkCTreeFunc  func,
					     gpointer      data);
void       gtk_ctree_pre_recursive          (GtkCTree     *ctree, 
					     GList        *node,
					     GtkCTreeFunc  func,
					     gpointer      data);
gboolean   gtk_ctree_is_visible             (GtkCTree     *ctree, 
					     GList        *node);
GList *    gtk_ctree_last                   (GtkCTree     *ctree,
					     GList        *node);
gint       gtk_ctree_find                   (GtkCTree     *ctree,
					     GList        *node,
					     GList        *child);
gboolean   gtk_ctree_is_ancestor            (GtkCTree     *ctree,
					     GList        *node,
					     GList        *child);
GList *    gtk_ctree_find_by_row_data       (GtkCTree     *ctree,
					     GList        *node,
					     gpointer      data);
gboolean   gtk_ctree_is_hot_spot            (GtkCTree     *ctree,
					     gint          x,
					     gint          y);

/***********************************************************
 *   Tree signals : move, expand, collapse, (un)select     *
 ***********************************************************/

void       gtk_ctree_move                   (GtkCTree     *ctree,
					     GList        *node,
					     GList        *new_parent, 
					     GList        *new_sibling);
void       gtk_ctree_expand                 (GtkCTree     *ctree,
					     GList        *node);
void       gtk_ctree_expand_recursive       (GtkCTree     *ctree,
					     GList        *node);
void       gtk_ctree_collapse               (GtkCTree     *ctree,
					     GList        *node);
void       gtk_ctree_collapse_recursive     (GtkCTree     *ctree,
					     GList        *node);
void       gtk_ctree_select                 (GtkCTree     *ctree, 
					     GList        *node);
void       gtk_ctree_select_recursive       (GtkCTree     *ctree, 
					     GList        *node);
void       gtk_ctree_unselect               (GtkCTree     *ctree, 
					     GList        *node);
void       gtk_ctree_unselect_recursive     (GtkCTree     *ctree, 
					     GList        *node);
void       gtk_ctree_real_select_recursive  (GtkCTree     *ctree, 
					     GList        *node, 
					     gint          state);

/***********************************************************
 *           Analogons of GtkCList functions               *
 ***********************************************************/

void       gtk_ctree_set_text               (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     gchar        *text);
void       gtk_ctree_set_pixmap             (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     GdkPixmap    *pixmap,
					     GdkBitmap    *mask);
void       gtk_ctree_set_pixtext            (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     gchar        *text,
					     guint8        spacing,
					     GdkPixmap    *pixmap,
					     GdkBitmap    *mask);
void       gtk_ctree_set_node_info          (GtkCTree     *ctree,
					     GList        *node,
					     gchar        *text,
					     guint8        spacing,
					     GdkPixmap    *pixmap_closed,
					     GdkBitmap    *mask_closed,
					     GdkPixmap    *pixmap_opened,
					     GdkBitmap    *mask_opened,
					     gboolean      is_leaf,
					     gboolean      expanded);
void       gtk_ctree_set_shift              (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     gint          vertical,
					     gint          horizontal);
GtkCellType gtk_ctree_get_cell_type         (GtkCTree     *ctree,
					     GList        *node,
					     gint          column);
gint       gtk_ctree_get_text               (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     gchar       **text);
gint       gtk_ctree_get_pixmap             (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     GdkPixmap   **pixmap,
					     GdkBitmap   **mask);
gint       gtk_ctree_get_pixtext            (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     gchar       **text,
					     guint8       *spacing,
					     GdkPixmap   **pixmap,
					     GdkBitmap   **mask);
gint       gtk_ctree_get_node_info          (GtkCTree     *ctree,
					     GList        *node,
					     gchar       **text,
					     guint8       *spacing,
					     GdkPixmap   **pixmap_closed,
					     GdkBitmap   **mask_closed,
					     GdkPixmap   **pixmap_opened,
					     GdkBitmap   **mask_opened,
					     gboolean     *is_leaf,
					     gboolean     *expanded);
void       gtk_ctree_set_foreground         (GtkCTree     *ctree,
					     GList        *node,
					     GdkColor     *color);
void       gtk_ctree_set_background         (GtkCTree     *ctree,
					     GList        *node,
					     GdkColor     *color);
void       gtk_ctree_set_selection_mode     (GtkCTree     *ctree,
					     GtkSelectionMode  mode);
void       gtk_ctree_set_row_data           (GtkCTree     *ctree,
					     GList        *node,
					     gpointer      data);
void       gtk_ctree_set_row_data_full      (GtkCTree     *ctree,
					     GList        *node,
					     gpointer      data,
					     GtkDestroyNotify destroy);
gpointer   gtk_ctree_get_row_data           (GtkCTree     *ctree,
					     GList        *node);
void       gtk_ctree_scroll_to              (GtkCTree     *ctree,
					     GList        *node,
					     gint          column,
					     gfloat        row_align,
					     gfloat        col_align);

/***********************************************************
 *             GtkCTree specific functions                 *
 ***********************************************************/

void       gtk_ctree_set_indent             (GtkCTree     *ctree, 
                                             gint          indent);
void       gtk_ctree_set_reorderable        (GtkCTree     *ctree,
					     gboolean      reorderable);
void       gtk_ctree_set_use_drag_icons     (GtkCTree     *ctree,
					     gboolean      use_icons);
void       gtk_ctree_set_line_style         (GtkCTree     *ctree, 
					     GtkCTreeLineStyle line_style);

/***********************************************************
 *             Tree sorting functions                      *
 ***********************************************************/

void       gtk_ctree_set_auto_sort          (GtkCTree     *ctree,
					     gboolean      auto_sort);
void       gtk_ctree_set_compare_func       (GtkCTree     *ctree,
					     GtkCTreeCompareFunc cmp_func);
void       gtk_ctree_sort                   (GtkCTree     *ctree, 
					     GList        *node);
void       gtk_ctree_sort_recursive         (GtkCTree     *ctree, 
					     GList        *node);
</comment>
