<copyright> gtomk Editable class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Editable.t,v 1.6 1998/07/21 15:57:15 yacc Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkEditable: GtkWidget

end;

implementation instance
GtkEditable

<doc> Return the {gtkEditable} for which this object stands.  </doc>
pointer
  gtkEditable
{
  = object;
}

void
  select_region (int, int) (start, the_end)
{
  pointer obj = object;
<c>
  gtk_editable_select_region (obj, start, the_end);
</c>
}

int (new_position)
  insert_text (String, int) (text, position)
{
  pointer obj = object;
  int len;
<c>
  {
    char *s;
    gint pos = position;
    C_STRING_WITH_TOM_STRING (s, len, text);
    gtk_editable_insert_text (obj, s, len, &pos);
    new_position = pos;
  }
</c>
}

void
  delete_text (int, int) (start_pos, end_pos)
{
  pointer obj = object;
<c>
  gtk_editable_delete_text (obj, start_pos, end_pos);
</c>
}

String (text)
  get_chars (int, int) (start_pos, end_pos)
{
  pointer obj = object;
<c>
  {
    char *s = gtk_editable_get_chars (obj, start_pos, end_pos);
    text = (void *) byte_string_with_c_string (s);
    g_free (s);
  }
</c>
}

/* time is signed, should be guint32...
 * Fri Apr  3 14:46:14 1998, tiggr@gerbil.org
 */
void
  cut_clipboard
{
  pointer obj = object;
<c>
  gtk_editable_cut_clipboard (obj);
</c>
}

void
  copy_clipboard
{
  pointer obj = object;
<c>
  gtk_editable_copy_clipboard (obj);
</c>
}

void
  paste_clipboard
{
  pointer obj = object;
<c>
  gtk_editable_paste_clipboard (obj);
</c>
}

void
  claim_selection (boolean, int) (claim, time)
{
  pointer obj = object;
<c>
  gtk_editable_claim_selection (obj, claim, time);
</c>
}

void
  delete_selection
{
  pointer obj = object;
<c>
  gtk_editable_delete_selection (obj);
</c>
}

void
  changed
{
  pointer obj = object;
<c>
  gtk_editable_changed (obj);
</c>
}

end;
