<copyright> gtomk List class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: List.t,v 1.7 1998/04/22 09:19:54 yacc Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkList: GtkContainer

instance (id)
  new
{
  pointer p;
<c>
  p = gtk_list_new ();
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkList

<doc> Return the {gtkList} for which this object stands.  </doc>
pointer
  gtkList
{
  = object;
}

void
  insert_items (Indexed, int) (items, position)
{
  pointer obj = object, list;
  int i, n = [items length];

  // An example of very tidy, and probably overkill...
  // Thu Apr  2 23:41:36 1998, tiggr@gerbil.org
  unwind ({<c> g_list_free (list); </c>})
    ({
      for (i = 0; i < n; i++)
	{
	  GtkItem item = items[i];
	  pointer item_obj = [item gtkItem];
	  <c>
	     list = g_list_append (list, item_obj);
	  </c>
	}
      <c>
	 gtk_list_insert_items (obj, list, position);
      </c>
      list = ({pointer null;});
    });
}

void
  append_items Indexed items
{
  pointer obj = object, list;
  int i, n = [items length];

  // An example of very tidy, and probably overkill...
  // Thu Apr  2 23:41:36 1998, tiggr@gerbil.org
  unwind ({<c> g_list_free (list); </c>})
    ({
      for (i = 0; i < n; i++)
	{
	  GtkItem item = items[i];
	  pointer item_obj = [item gtkItem];
	  <c>
	     list = g_list_append (list, item_obj);
	  </c>
	}
      <c>
	 gtk_list_append_items (obj, list);
      </c>
      list = ({pointer null;});
    });
}

void
  prepend_items Indexed items
{
  pointer obj = object, list;
  int i, n = [items length];

  // An example of very tidy, and probably overkill...
  // Thu Apr  2 23:41:36 1998, tiggr@gerbil.org
  unwind ({<c> g_list_free (list); </c>})
    ({
      for (i = 0; i < n; i++)
	{
	  GtkItem item = items[i];
	  pointer item_obj = [item gtkItem];
	  <c>
	     list = g_list_append (list, item_obj);
	  </c>
	}
      <c>
	 gtk_list_prepend_items (obj, list);
      </c>
      list = ({pointer null;});
    });
}

void
  remove_items Indexed items
{
  pointer obj = object, list;
  int i, n = [items length];

  for (i = 0; i < n; i++)
    {
      GtkItem item = items[i];
      pointer item_obj = [item gtkItem];
      <c>
	 list = g_list_append (list, item_obj);
      </c>
    }
  <c>
     gtk_list_remove_items (obj, list);
  </c>
}

void
  remove_items_no_unref Indexed items
{
  pointer obj = object, list;
  int i, n = [items length];

  for (i = 0; i < n; i++)
    {
      GtkItem item = items[i];
      pointer item_obj = [item gtkItem];
      <c>
	 list = g_list_append (list, item_obj);
      </c>
    }
  <c>
     gtk_list_remove_items_no_unref (obj, list);
  </c>
}

void
  clear_items (int, int) (start, the_end)
{
  pointer obj = object;
<c>
  gtk_list_clear_items (obj, start, the_end);
</c>
}

void
  select_item int item
{
  pointer obj = object;
<c>
  gtk_list_select_item (obj, item);
</c>
}

void
  unselect_item int item
{
  pointer obj = object;
<c>
  gtk_list_unselect_item (obj, item);
</c>
}

void
  select_child GtkWidget child
{
  pointer obj = object, widget_obj = [child gtkWidget];
<c>
  gtk_list_select_child (obj, widget_obj);
</c>
}

void
  unselect_child GtkWidget child
{
  pointer obj = object, widget_obj = [child gtkWidget];
<c>
  gtk_list_unselect_child (obj, widget_obj);
</c>
}

int (position)
  unselect_child GtkWidget child
{
  pointer obj = object, widget_obj = [child gtkWidget];
<c>
  position = gtk_list_child_position (obj, widget_obj);
</c>
}

void
  set_selection_mode int GTK_SELECTION_something
{
  pointer obj = object;
<c>
  gtk_list_set_selection_mode (obj, GTK_SELECTION_something);
</c>
}

ObjectArray
  selection
{
  pointer p=object;
  pointer selectionptr;
  <c> selectionptr=((GtkList *) p)->selection; </c>
  = [[[GList alloc] init selectionptr withWrapper [GtkWidget self]]
      asObjectArray];
}

end;
