<copyright> gtomk Menu class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Menu.t,v 1.7 1998/06/23 16:28:53 yacc Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkMenu: GtkMenuShell

instance (id)
  new
{
  pointer p;
<c>
  p = gtk_menu_new ();
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkMenu

<doc> Return the {gtkMenu} for which this object stands.  </doc>
pointer
  gtkMenu
{
  = object;
}

void
  append GtkWidget child
{
  pointer obj = object, child_obj = [child gtkWidget];
<c>
  gtk_menu_append (obj, child_obj);
</c>
}
  
void
  prepend GtkWidget child
{
  pointer obj = object, child_obj = [child gtkWidget];
<c>
  gtk_menu_prepend (obj, child_obj);
</c>
}

void
  insert (GtkWidget, int) (child, position)
{
  pointer obj = object, child_obj = [child gtkWidget];
<c>
  gtk_menu_insert (obj, child_obj, position);
</c>
}

void
  popup (GtkWidget, GtkWidget, pointer, pointer, int, int)
	(parent_menu_shell, parent_menu_item, func, data, button, activate_time)
{
  pointer obj = object, pms = [parent_menu_shell gtkWidget];
  pointer pmi = [parent_menu_item gtkWidget];
<c>
  gtk_menu_popup (obj, pms, pmi, func, data, button, activate_time);
</c>
}

void
  popdown
{
  pointer obj = object;
<c>
  gtk_menu_popdown (obj);
</c>
}

GtkWidget
  get_active
{
  pointer obj = object, p;
<c>
  p = gtk_menu_get_active (obj);
</c>
  = [GtkWidget proxy p];
}

void
  set_active int index
{
  pointer obj = object;
<c>
  gtk_menu_set_active (obj, index);
</c>
}

void
  set_accel_group pointer group
{
  pointer obj = object;
<c>
  gtk_menu_set_accel_group (obj, group);
</c>
}

void
  attach_to_widget (GtkWidget, pointer) (attach_widget, detacher)
{
  pointer obj = object, widget_obj = [attach_widget gtkWidget];
<c>
  gtk_menu_attach_to_widget (obj, widget_obj, detacher);
</c>
}

GtkWidget
  get_attach_widget
{
  pointer obj = object, p;
<c>
  p = gtk_menu_get_attach_widget (obj);
</c>
  = [GtkWidget proxy p];
}

void
  detach
{
  pointer obj = object;
<c>
  gtk_menu_detach (obj);
</c>
}

end;
