<copyright> gtomk Tree class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Tree.t,v 1.4 1998/04/14 13:26:10 tiggr Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkTree: GtkContainer

instance (id)
  new
{
  pointer p;
<c>
  p = gtk_tree_new ();
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkTree

<doc> Return the {gtkTree} for which this object stands.  </doc>
pointer
  gtkTree
{
  = object;
}

void
  append GtkWidget tree_item
{
  pointer obj = object, tree_item_obj = [tree_item gtkWidget];
<c>
  gtk_tree_append (obj, tree_item_obj);
</c>
}

void
  prepend GtkWidget tree_item
{
  pointer obj = object, tree_item_obj = [tree_item gtkWidget];
<c>
  gtk_tree_prepend (obj, tree_item_obj);
</c>
}

void
  insert (GtkWidget, int) (tree_item, position)
{
  pointer obj = object, tree_item_obj = [tree_item gtkWidget];
<c>
  gtk_tree_insert (obj, tree_item_obj, position);
</c>
}

void
  remove_items Indexed items
{
  pointer obj = object, list;
  int i, n = [items length];

  for (i = 0; i < n; i++)
    {
      GtkItem item = items[i];
      pointer item_obj = [item gtkItem];
      <c>
	 list = g_list_append (list, item_obj);
      </c>
    }
  <c>
     gtk_tree_remove_items (obj, list);
  </c>
}

void
  clear_items (int, int) (start, the_end)
{
  pointer obj = object;
<c>
  gtk_tree_clear_items (obj, start, the_end);
</c>
}

void
  select_item int item
{
  pointer obj = object;
<c>
  gtk_tree_select_item (obj, item);
</c>
}

void
  unselect_item int item
{
  pointer obj = object;
<c>
  gtk_tree_unselect_item (obj, item);
</c>
}

void
  select_child GtkWidget tree_item
{
  pointer obj = object, tree_item_obj = [tree_item gtkWidget];
<c>
  gtk_tree_select_child (obj, tree_item_obj);
</c>
}

void
  unselect_child GtkWidget tree_item
{
  pointer obj = object, tree_item_obj = [tree_item gtkWidget];
<c>
  gtk_tree_unselect_child (obj, tree_item_obj);
</c>
}

void
  child_position GtkWidget child
{
  pointer obj = object, child_obj = [child gtkWidget];
<c>
  gtk_tree_child_position (obj, child_obj);
</c>
}

void
  set_selection_mode int GTK_SELECTION_something
{
  pointer obj = object;
<c>
  gtk_tree_set_selection_mode (obj, GTK_SELECTION_something);
</c>
}

void
  gtk_tree_set_view_mode int GTK_TREE_VIEW_something
{
  pointer obj = object;
<c>
  gtk_tree_set_view_mode (obj, GTK_TREE_VIEW_something);
</c>
}

void
  set_view_lines boolean flag
{
  pointer obj = object;
<c>
  gtk_tree_set_view_lines (obj, flag);
</c>
}

end;
