<copyright> gtomk TreeItem class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: TreeItem.t,v 1.4 1998/04/14 13:26:11 tiggr Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkTreeItem: GtkItem

instance (id)
  new
{
  pointer p;
<c>
  p = gtk_tree_item_new ();
</c>
  = [[self alloc] init p];
}

<doc> Create a new tree item, using {gtk_tree_item_new_with_label}.
    </doc>
instance (id)
  new_with_label String label
{
  pointer p;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, label);
    p = gtk_tree_item_new_with_label (s);
  }
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkTreeItem

<doc> Return the {gtkTreeItem} for which this object stands.  </doc>
pointer
  gtkTreeItem
{
  = object;
}

void
  set_subtree GtkWidget subtree
{
  pointer obj = object, subtree_obj = [subtree gtkWidget];
<c>
  gtk_tree_item_set_subtree (obj, subtree_obj);
</c>
}

void
  remove_subtree
{
  pointer obj = object;
<c>
  gtk_tree_item_remove_subtree (obj);
</c>
}

void
  select
{
  pointer obj = object;
<c>
  gtk_tree_item_select (obj);
</c>
}

void
  deselect
{
  pointer obj = object;
<c>
  gtk_tree_item_deselect (obj);
</c>
}

void
  expand
{
  pointer obj = object;
<c>
  gtk_tree_item_expand (obj);
</c>
}

void
  collapse
{
  pointer obj = object;
<c>
  gtk_tree_item_collapse (obj);
</c>
}

end;
