<copyright> gtomk Viewport class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Viewport.t,v 1.5 1998/07/07 11:54:57 yacc Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkViewport: GtkBin

instance (id)
  new (GtkAdjustment, GtkAdjustment) (hadjustment, vadjustment)
{
  pointer p, hobj, vobj;
  if (hadjustment)
    hobj = [hadjustment gtkAdjustment];
  if (vadjustment)
    vobj = [vadjustment gtkAdjustment];
<c>
  p = gtk_viewport_new (hobj, vobj);
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkViewport

<doc> Return the {gtkViewport} for which this object stands.  </doc>
pointer
  gtkViewport
{
  = object;
}

GtkAdjustment (hadjustment)
  get_hadjustment
{
  pointer p, obj = object;
<c>
  p = gtk_viewport_get_hadjustment (obj);
</c>
  if (!!p)
    hadjustment = [GtkAdjustment proxy p];
}

GtkAdjustment (vadjustment)
  get_vadjustment
{
  pointer p, obj = object;
<c>
  p = gtk_viewport_get_vadjustment (obj);
</c>
  if (!!p)
    vadjustment = [GtkAdjustment proxy p];
}

void
  set_hadjustment GtkAdjustment adjustment
{
  pointer obj = object, adjustment_obj;
  if (adjustment)
    adjustment_obj = [adjustment gtkAdjustment];
<c>
  gtk_viewport_set_hadjustment (obj, adjustment_obj);
</c>
}

void
  set_vadjustment GtkAdjustment adjustment
{
  pointer obj = object, adjustment_obj;
  if (adjustment) 
    adjustment_obj = [adjustment gtkAdjustment];
<c>
  gtk_viewport_set_vadjustment (obj, adjustment_obj);
</c>
}

void
  set_shadow_type int GTK_SHADOW_something
{
  pointer obj = object;
<c>
  gtk_viewport_set_shadow_type (obj, GTK_SHADOW_something);
</c>
}

end;
