<copyright> tomgnome Spell class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: Spell.t,v 1.3 1999/02/17 23:32:54 tiggr Exp $</id>
    </copyright>

<gnome_version>0.99.8</gnome_version>
<gtk_version>1.1.15</gtk_version>

<c>
#include <libgnome/libgnome.h>
#include <libgnomeui/gnome-spell.h>
#include <tom/util.h>
</c>

implementation class
GnomeSpell: GtkVBox

instance (id)
  new
{
  pointer spell;
  <c> spell = gnome_spell_new (); </c>
  = [[self alloc] init spell];
}

end;

implementation instance
GnomeSpell

<doc> Return the {GnomeSpell} for which this object stands.  </doc>
pointer
  gnomeSpell
{
  = object;
}

<doc> check str for mispelled words  returns 0 if words are ok. </doc>

int (res)
  check String str
{
  pointer obj = object;
  <c> {
    int len;
    char *cstr;
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cstr, len, str);
    res = gnome_spell_check (obj, cstr);
  } </c>
}

<doc> accept word for this session only. </doc>

void
  accept String word
{
  pointer obj = object;
  <c> {
    int len;
    char *cword;
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cword, len, word);
    gnome_spell_accept (obj, cword);
  } </c>
}

<doc> insert word in personal dictionary. </doc>
void
  insert String word
  lowercase: boolean lcase = TRUE
{
  pointer obj = object;
  <c> {
    int len;
    char *cword;
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cword, len, word);
    gnome_spell_insert (obj, cword, lcase);
  } </c>
}

<doc> go for the next word. </doc>
int (res)
  next
{
  pointer obj = object;
  <c> res = gnome_spell_next (obj); </c>
}

<doc> kill the ispell process. </doc>

void
  kill
{
  pointer obj = object;
  <c> gnome_spell_kill (obj); </c>
}

end;
