<copyright> tomgnome I18n support.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: i18n.t,v 1.3 1999/02/17 23:32:58 tiggr Exp $</id>
    </copyright>

<gtk_version>1.1.0</gtk_version>

<c>
#include <libgnome/libgnome.h>
#include <libgnome/gnome-i18n.h>
#include <tom/util.h>
</c>

implementation class
String extension gnomei18n : tom.Constants
{
  static OutputStream collectsymbol;
}

void 
  bindtextdomain String package
            dir: String dir = nil
{
  <c> {
    int len;
    char *cpackage;
    char *cdir = "/usr/share";
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cpackage, len, package);
    if (dir)
      C_STRING_WITH_TOM_STRING (cdir, len, dir);
    bindtextdomain (cpackage, cdir);
  } </c>
}

void 
  textdomain String package
{
  <c> {
    int len;
    char *cpackage;
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cpackage, len, package);
    textdomain (cpackage);
  } </c>
}

OutputStream
  help OutputStream s
  done MutableKeyed done
{
  class (String) cls = [String self];

  if (!done[cls])
    {
      [done add cls];

      s = [[s print "tom.String I18n/TomGnome
 control options:
  :i18n-output <f>      output the message catalog to <f>"] nl];
    }
  = s;
}

<doc> Scan the arguments to the program for something telling us whether
    or how to do certain things.

    See the output of {:help} of any TOM program for short information on
    the options.  </doc>
void
  load MutableArray arguments
{
  int i, n = [arguments length];

  for (i = 0; i < n;) {
    ByteString a = arguments[i];
    String s;

    if ([a length] > 0 && a[0] == ':') {
      int hit;
      
      if ([":i18n-output" equal a] && i < n - 1) {
	File f = [File open arguments[i + 1] output: YES flags: FILE_EXIST_TRUNCATE|FILE_NOT_EXIST_CREATE];
	collectsymbol = [BufferedStream with f];
	hit = 2;
      }
      if (hit != 0) {
	[arguments removeElements (i, hit)];
	n -= hit;
      } else
	i++;
    } else
      i++;
  }
}

end;

implementation instance
String extension gnomei18n

<doc> Return the localized string via gettext. comment is a potential
      comment for the translation writer. </doc>
String (res)
  i18n: String comment
{
  if (collectsymbol != nil)
    {
      if (comment)
	[collectsymbol print ("#:", comment, "\n")];
      [[collectsymbol print ("msgid ",[self cstring],"\nmsgstr \"\"")] nl];
    }

  <c> {
    int len;
    char *cself;
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cself, len, self);
    cself = gettext (cself);
    res = (void *) byte_string_with_c_string (cself);
  } </c>
}

String
  i18n
{
  = [self i18n: nil];
}

String
  cstring
{
  MutableByteString res = [MutableByteString new];
  [res print '"'];
  
  int i, n = [self length];

  for (i = 0; i < n; i++) {
    byte b = self[i];

    if (b == '\n')
      [res print "\\n"];
    else if (b == '\\')
      [res print '\\'];
    else if ((b < 32) || (b > 127)) {
      [res print "\\x"];
	  
      byte upnibble = b / byte(16);
      byte lownibble = b % byte(16);
      
      if (upnibble < 10) {
	b = '0' + upnibble;
	[res print b];
      } else {
	b = 'A' + upnibble - byte(10);
	[res print b];
      }
      if (lownibble < 10) {
	b = '0' + lownibble;
	[res print b];
      } else {
	b = 'A' + lownibble - byte(10);
	[res print b];
      }
    } else 
      [res print b];
  }
  [res print '"'];
  = res;
}

end;
